# NetworkLayout.jl
Layout algorithms for graphs and trees in pure Julia.

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliagraphs.org/NetworkLayout.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliagraphs.org/NetworkLayout.jl/dev/)
[![Build Status](https://github.com/JuliaGraphs/NetworkLayout.jl/workflows/CI/badge.svg)](https://github.com/JuliaGraphs/NetworkLayout.jl/actions)
[![Coverage](https://codecov.io/gh/JuliaGraphs/NetworkLayout.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaGraphs/NetworkLayout.jl)

## Installation
``` julia
pkg> add NetworkLayout
```
## Algorithms
The available algorithms and their parameters can be found in the
[docs](https://juliagraphs.org/NetworkLayout.jl/stable).

All of the algorithms represent mappings `adjacency matrix ↦ vector of
positions` where the positions are represented by the `Point` datatype from
[`GeometryBasics.jl](https://github.com/JuliaGeometry/GeometryBasics.jl)

``` julia
using NetworkLayout
using Graphs

adj_matrix = adjacency_matrix(wheel_graph(10))

pos = spring(adj_matrix; iterations=20)
pos = algorithm(adj_matrix)
```
There is also a "delayed" functor version of each algorithm:
```julia
layout = Spring(; iterations=20)
pos = layout(adj_matrix)
```
Instead of passing a adjacency matrix on can also pass `Graphs.jl` graphs directly.

#! julia --startup-file=no

using Pkg
Pkg.activate(@__DIR__)
Pkg.develop(PackageSpec(path=dirname(@__DIR__))) # adds the package this script is called from
Pkg.update()
Pkg.instantiate()

using LiveServer
@async serve(dir=joinpath(@__DIR__, "build"))

run = true
while run
    try
        include("make.jl")
    catch e
        @info "make.jl error" e
    end

    println("Run again? Enter! Exit with 'q'.")
    if readline() == "q"
        global run = false
    end
end

using NetworkLayout
using Graphs
using GeometryBasics
using DelimitedFiles: readdlm
using SparseArrays: sparse
using StaticArrays
using StableRNGs
using Test
using Random
using LinearAlgebra

NetworkLayout.DEFAULT_RNG[] = StableRNG

function jagmesh()
    jagmesh_path = joinpath(dirname(@__FILE__), "jagmesh1.mtx")
    array = round.(Int, open(readdlm, jagmesh_path))
    row = array[:, 1]
    col = array[:, 2]
    entry = [(1:3600)...]
    return sparse(row, col, entry)
end
jagmesh_adj = jagmesh()

@testset "Testing NetworkLayout" begin
    @testset "Testing SFDP" begin
        println("SFDP")
        @testset "SFDP construction" begin
            algo = SFDP()
            @test algo isa SFDP{2,Float64}
            algo = SFDP(; dim=3, Ptype=Int)
            @test algo isa SFDP{3,Int}
            ip = [(1, 2.0, 3.0), (1, 2.0, 3)]
            algo = SFDP(; initialpos=ip)
            @test algo isa SFDP{3,Float64}
            ip = [Point2f(1, 2)]
            algo = SFDP(; initialpos=ip)
            @test algo isa SFDP{2,Float32}
        end

        @testset "iterator size" begin
            for l in [1, 10, 100]
                adj_matrix = adjacency_matrix(wheel_graph(10))
                it = LayoutIterator(SFDP(; iterations=l, tol=0.0), adj_matrix)
                vec = Any[]
                for p in it
                    push!(vec, p)
                end
                @test length(vec) == l
                @test length(unique!(vec)) == l
            end
        end

        @testset "Testing Jagmesh1 graph" begin
            println("SFDP Jagmesh1")
            positions = @time SFDP(; dim=2, Ptype=Float32, tol=0.9, K=1, iterations=10)(jagmesh_adj)
            @test typeof(positions) == Vector{Point2f}
            positions = @time SFDP(; dim=3, Ptype=Float32, tol=0.9, K=1, iterations=10)(jagmesh_adj)
            @test typeof(positions) == Vector{Point3f}
        end

        @testset "Testing wheel_graph" begin
            println("SFDP Wheelgraph")
            g = wheel_graph(10)
            adj_matrix = adjacency_matrix(g)
            positions = @time SFDP(; dim=2, Ptype=Float32, tol=0.1, K=1)(adj_matrix)
            @test typeof(positions) == Vector{Point2f}
            @test positions == sfdp(adj_matrix; dim=2, Ptype=Float32, tol=0.1, K=1)
            positions = @time SFDP(; dim=3, Ptype=Float32, tol=0.1, K=1)(adj_matrix)
            @test typeof(positions) == Vector{Point3f}
            @test positions == sfdp(adj_matrix; dim=3, Ptype=Float32, tol=0.1, K=1)

            NetworkLayout.DEFAULT_RNG[] = StableRNG
            l = SFDP()
            @test l.rng isa StableRNG
            li = LayoutIterator(l, g)
            p1, p2 = iterate(li)[1], iterate(li)[1]
            @test p1 == p2
            NetworkLayout.DEFAULT_RNG[] = MersenneTwister
        end
    end

    @testset "Testing Stress Majorization Algorithm" begin
        println("Stress")
        @testset "Stress construction" begin
            algo = Stress()
            @test algo isa Stress{2,Float64}
            algo = Stress(; dim=3, Ptype=Int)
            @test algo isa Stress{3,Int}
            ip = [(1, 2.0, 3.0), (1, 2.0, 3)]
            algo = Stress(; initialpos=ip)
            @test algo isa Stress{3,Float64}
            ip = [Point2f(1, 2)]
            algo = Stress(; initialpos=ip)
            @test algo isa Stress{2,Float32}
        end

        @testset "iterator size" begin
            for l in [1, 10, 100]
                adj_matrix = adjacency_matrix(wheel_graph(10))
                it = LayoutIterator(Stress(; iterations=l, abstolx=0.0, reltols=0.0, abstols=0.0), adj_matrix)
                vec = Any[]
                for p in it
                    push!(vec, p)
                end
                @test length(vec) == l
                @test length(unique!(vec)) == l
            end
        end

        @testset "Testing Jagmesh1 graph" begin
            println("Stress Jagmesh1")
            positions = @time Stress(; iterations=10, Ptype=Float32)(jagmesh_adj)
            @test typeof(positions) == Vector{Point2f}
            positions = @time Stress(; iterations=10, dim=3, Ptype=Float32)(jagmesh_adj)
            @test typeof(positions) == Vector{Point3f}
        end

        @testset "Testing wheel_graph" begin
            println("Stress wheel_graph")
            g = wheel_graph(10)
            adj_matrix = adjacency_matrix(g)
            positions = @time Stress(; iterations=10, Ptype=Float32)(adj_matrix)
            @test typeof(positions) == Vector{Point2f}
            @test positions == stress(adj_matrix; iterations=10, Ptype=Float32)
            positions = @time Stress(; iterations=10, dim=3, Ptype=Float32)(adj_matrix)
            @test typeof(positions) == Vector{Point3f}
            @test positions == stress(adj_matrix; iterations=10, dim=3, Ptype=Float32)

            NetworkLayout.DEFAULT_RNG[] = StableRNG
            l = Stress()
            @test l.rng isa StableRNG
            li = LayoutIterator(l, g)
            p1, p2 = iterate(li)[1], iterate(li)[1]
            @test p1 == p2
            NetworkLayout.DEFAULT_RNG[] = MersenneTwister
        end

        @testset "test pairwise_distance" begin
            using NetworkLayout: make_symmetric!, pairwise_distance
            δ = [0 1 0 0 1;
                 1 0 0 1 0;
                 0 0 0 1 1;
                 0 1 1 0 0;
                 1 0 1 0 0]
            d = pairwise_distance(δ)

            @test d == make_symmetric!([0 1 2 2 1;
                                        0 0 2 1 2;
                                        0 0 0 1 1;
                                        0 0 0 0 2;
                                        0 0 0 0 0])

        end

        @testset "test unconnected graphs" begin
            _δ = [0 1 1;
                  1 0 1;
                  1 1 0]
            N = 10# 10 fully connected 3-node graphs
            δ = kron(Matrix(I, N, N), _δ);
            g = SimpleGraph(δ)
            pos = Stress()(g)
            @test all(norm.(pos) .< 2)
            # graphplot(g; layout=Stress())

            sgkeys = [:bull, :chvatal, :cubical, :desargues,
                      :diamond, :dodecahedral, :frucht, :heawood,
                      :house, :housex, :icosahedral, :karate, :krackhardtkite,
                      :moebiuskantor, :octahedral, :pappus, :petersen,
                      :sedgewickmaze, :tetrahedral, :truncatedcube,
                      :truncatedtetrahedron, :truncatedtetrahedron_dir, :tutte]
            gs = filter(!is_directed, smallgraph.(sgkeys))
            absdim = mapreduce(nv, +, gs)
            adj = zeros(Int, absdim, absdim);
            let i = 1
                for g in gs
                    r = i:i+nv(g)-1
                    adj[r, r] .= adjacency_matrix(g)
                    i += nv(g)
                end
            end
            g = SimpleGraph(adj)

            pos = Stress()(g)
            @test all(norm.(pos) .< 20)
            # graphplot(g; layout=Stress())
        end
    end

    @testset "Testing Spring Algorithm" begin
        println("Spring wheel_graph")
        @testset "Spring construction" begin
            algo = Spring()
            @test algo isa Spring{2,Float64}
            algo = Spring(; dim=3, Ptype=Int)
            @test algo isa Spring{3,Int}
            ip = [(1, 2.0, 3.0), (1, 2.0, 3)]
            algo = Spring(; initialpos=ip)
            @test algo isa Spring{3,Float64}
            ip = [Point2f(1, 2)]
            algo = Spring(; initialpos=ip)
            @test algo isa Spring{2,Float32}
        end

        @testset "iterator size" begin
            for l in [1, 10, 100]
                adj_matrix = adjacency_matrix(wheel_graph(10))
                it = LayoutIterator(Spring(; iterations=l), adj_matrix)
                vec = Any[]
                for p in it
                    push!(vec, p)
                end
                @test length(vec) == l
                @test length(unique!(vec)) == l
            end
        end

        @testset "Testing wheel_graph" begin
            g = wheel_graph(10)
            adj_matrix = adjacency_matrix(g)
            positions = @time Spring(; C=2.0, iterations=100, initialtemp=2.0, Ptype=Float32)(adj_matrix)
            @test typeof(positions) == Vector{Point2f}
            @test positions == spring(adj_matrix; C=2.0, iterations=100, initialtemp=2.0, Ptype=Float32)
            positions = @time Spring(; C=2.0, iterations=100, initialtemp=2.0, Ptype=Float32, dim=3)(adj_matrix)
            @test typeof(positions) == Vector{Point3f}
            @test positions ==
                  spring(adj_matrix; C=2.0, iterations=100, initialtemp=2.0, Ptype=Float32, dim=3)

            NetworkLayout.DEFAULT_RNG[] = StableRNG
            l = Spring()
            @test l.rng isa StableRNG
            li = LayoutIterator(l, g)
            p1, p2 = iterate(li)[1], iterate(li)[1]
            @test p1 == p2
            NetworkLayout.DEFAULT_RNG[] = MersenneTwister
        end

        @testset "test single node graph" begin
            g = SimpleGraph(1)
            pos = Spring()(g)
            @test length(pos) == 1
            @test !isnan(pos[1])
        end
    end

    @testset "Testing Spectral Algorithm" begin
        println("Spectral wheel_graph")
        @testset "Testing wheel_graph" begin
            g = wheel_graph(10)
            adj_matrix = adjacency_matrix(g)
            positions = @time Spectral()(adj_matrix)
            @test typeof(positions) == Vector{Point{3,Float64}}
            @test positions == spectral(adj_matrix)
            positions = @time Spectral(; Ptype=Float32)(adj_matrix)
            @test typeof(positions) == Vector{Point{3,Float32}}
            @test positions == spectral(adj_matrix; Ptype=Float32)
        end
    end

    @testset "Testing Shell Layout Algorithm" begin
        println("Shell wheel_graph")

        @testset "Testing wheel_graph" begin
            g = wheel_graph(10)
            adj_matrix = adjacency_matrix(g)
            positions = @time Shell()(adj_matrix)
            @test typeof(positions) == Vector{Point{2,Float64}}
            @test positions == shell(adj_matrix)
        end
        @testset "Testing Base Case" begin
            g = Graph(1)
            adj_matrix = adjacency_matrix(g)
            positions = @time Shell()(adj_matrix)
            @test typeof(positions) == Vector{Point{2,Float64}}
        end
    end

    @testset "Testing Buchheim Tree Drawing" begin
        println("Buchheim")
        using NetworkLayout: adj_mat_to_list

        @testset "matrix -> list conversion" begin
            g = wheel_graph(5)
            mat = adjacency_matrix(g)
            list = adj_mat_to_list(mat)
            @test list == [[2, 3, 4, 5], [1, 3, 5], [1, 2, 4], [1, 3, 5], [1, 2, 4]]

            g = SimpleDiGraph(7)
            add_edge!(g, 1, 2)
            add_edge!(g, 1, 3)
            add_edge!(g, 1, 4)
            add_edge!(g, 2, 5)
            add_edge!(g, 2, 6)
            add_edge!(g, 3, 7)
            mat = adjacency_matrix(g)

            list = adj_mat_to_list(mat)
            @test list == [[2, 3, 4], [5, 6], [7], [], [], [], []]
        end

        @testset "Test a Random tree" begin
            println("Buchheim Random")
            adj_list = Vector{Int}[[2, 3, 4], [5, 6], [7], [], [], [], []]
            nodesize = [1, 2, 1.5, 3, 0.5, 1, 1]
            locs = @time Buchheim(; nodesize)(adj_list)
            @test typeof(locs) == Vector{Point{2,Float64}}
            @test locs == buchheim(adj_list; nodesize)
            locs = @time Buchheim(; Ptype=Float32)(adj_list)
            @test typeof(locs) == Vector{Point{2,Float32}}
        end

        @testset "Test a Binary tree" begin
            println("Buchheim binary_tree")
            g = binary_tree(10)
            dirg = SimpleDiGraph(collect(edges(g)))
            a = adjacency_matrix(dirg)
            locs = @time Buchheim()(a)
            @test typeof(locs) == Vector{Point{2,Float64}}
        end

        @testset "test requirements" begin
            # more than one parent
            g = SimpleDiGraph(3)
            add_edge!(g, 1, 2)
            add_edge!(g, 1, 3)
            add_edge!(g, 2, 3)
            @test_throws ArgumentError Buchheim()(g)

            # node 1 not parent
            g = SimpleDiGraph(3)
            add_edge!(g, 2, 1)
            add_edge!(g, 2, 3)
            @test_throws ArgumentError Buchheim()(g)

            # not all nodes reached
            g = SimpleDiGraph(4)
            add_edge!(g, 1, 2)
            add_edge!(g, 2, 3)
            @test_throws ArgumentError Buchheim()(g)
        end
    end

    @testset "Testing Square Grid Layout" begin
        println("SquareGrid")
        @testset "Testing col length" begin
            M = adjacency_matrix(SimpleGraph(4))
            positions = SquareGrid(; Ptype=Int)(M)
            @test positions == Point2.([(0, 0), (1, 0), (0, -1), (1, -1)])
            @test positions == squaregrid(M; Ptype=Int)

            M = adjacency_matrix(SimpleGraph(3))
            positions = SquareGrid(; Ptype=Int)(M)
            @test positions == Point2.([(0, 0), (1, 0), (0, -1)])
            @test positions == squaregrid(M; Ptype=Int)

            M = adjacency_matrix(SimpleGraph(5))
            positions = SquareGrid(; Ptype=Int, cols=2)(M)
            @test positions == Point2.([(0, 0), (1, 0), (0, -1), (1, -1), (0, -2)])
            @test positions == squaregrid(M; Ptype=Int, cols=2)
        end

        @testset "Testing dx,dy" begin
            M = adjacency_matrix(SimpleGraph(4))
            positions = SquareGrid(; Ptype=Int, dx=2, dy=3)(M)
            @test positions == Point2.([(0, 0), (2, 0), (0, 3), (2, 3)])
        end

        @testset "Testing skip" begin
            M = adjacency_matrix(SimpleGraph(4))
            positions = SquareGrid(; Ptype=Int, skip=[(1, 1), (2, 2)])(M)
            @test positions == Point2.([(1, 0), (2, 0), (0, -1), (2, -1)])
        end
    end

    @testset "test Graphs glue code" begin
        println("Test Graphs glue code")
        g = complete_graph(10)
        pos = Spring()(g)
        @test pos isa Vector{Point{2,Float64}}
    end

    @testset "test assert square" begin
        using NetworkLayout: assertsquare
        M1 = rand(2, 4)
        @test_throws ArgumentError assertsquare(M1)
        M2 = rand(4, 4)
        @test assertsquare(M2) == 4
        @test_throws ArgumentError buchheim(M1)
        @test_throws ArgumentError sfdp(M1)
        @test_throws ArgumentError shell(M1)
        @test_throws ArgumentError spectral(M1)
        @test_throws ArgumentError spring(M1)
        @test_throws ArgumentError squaregrid(M1)
        @test_throws ArgumentError stress(M1)
    end

    @testset "make_symmetric" begin
        using LinearAlgebra: issymmetric
        using NetworkLayout: make_symmetric!

        M = [1 0; 0 1]
        make_symmetric!(M)
        @test issymmetric(M)

        M = [0 1; 0 0]
        make_symmetric!(M)
        @test issymmetric(M)

        M = [0 0; 1 0]
        make_symmetric!(M)
        @test issymmetric(M)

        M = [0 -1; 1 0]
        @test_throws ArgumentError make_symmetric!(M)

        M = [1  0  2;
             6  2  4;
             2  0  3]
        make_symmetric!(M)
        @test M == [1  6  2;
                    6  2  4;
                    2  4  3]
    end

    @testset "infer ptype" begin
        using NetworkLayout: infer_pointtype
        @test infer_pointtype(Point2f(1,2)) == (2, Float32)
        @test infer_pointtype(Point2(1.0,2)) == (2, Float64)
        @test infer_pointtype(Point(1,2,4)) == (3, Int64)
        @test_throws ArgumentError infer_pointtype([(1,2), (2,3.2,1)])
        @test infer_pointtype([(1,2), (2,3.2)]) == (2, Float64)

        dany = Dict(1=>Point2(1,1), 4=>[1.0,2.0], 7=>(1.0, 4.0))
        @test infer_pointtype(dany) == (2, Float64)

        dany[2] = (1,2,3)
        @test_throws ArgumentError infer_pointtype(dany)
    end

    @testset "Sanitize initialpos pin"  begin
        using NetworkLayout: _sanitize_initialpos_pin
        pos = [(0,0),(1,1),(2,2)]
        pin = []
        _pos, _pin = _sanitize_initialpos_pin(2, Float64, pos, pin)
        @test _pos == Dict(pairs(Point2f.(pos)))
        @test _pin == Dict{Int, SVector{2, Bool}}()

        pos = [(0,0),(1,1),(2,2)]
        pin = Dict(1=>(true,false), 3=>true, 2=>(3.0, 3.0))
        _pos, _pin = _sanitize_initialpos_pin(2, Float64, pos, pin)
        @test _pos == Dict(1=>Point2f(0,0), 2=>Point2f(3.0,3.0), 3=>Point2f(2.0,2.0))
        @test _pin == Dict(1=>SVector(true,false), 2=>SVector(true,true), 3=>SVector(true,true))
    end

    @testset "test pin" begin
        for algo in [sfdp, spring, stress]
            g = complete_graph(10)
            ep = algo(g; pin=[(0,0), (0,0)])
            @test ep[1] == [0,0]
            @test ep[2] == [0,0]

            ep = algo(g; initialpos=Dict(4=>(0,0,0), 5=>(1,2,3)), pin=Dict(4=>true, 5=>(true, false, true)))
            @test ep[4] == [0,0,0]
            @test ep[5][[1,3]] == [1,3]
            @test ep[5][2] != [2]
        end
    end
end

module NetworkLayoutGraphsExt

if isdefined(Base, :get_extension)
    import NetworkLayout
    import Graphs
else
    import ..NetworkLayout
    import ..Graphs
end

function NetworkLayout.layout(l::NetworkLayout.AbstractLayout, g::Graphs.AbstractGraph)
    NetworkLayout.layout(l, Graphs.adjacency_matrix(g))
end
function NetworkLayout.LayoutIterator(l::NetworkLayout.IterativeLayout, g::Graphs.AbstractGraph)
    NetworkLayout.LayoutIterator(l, Graphs.adjacency_matrix(g))
end

end # module

export Buchheim, buchheim

"""
    Buchheim(; kwargs...)(adj_matrix)
    Buchheim(; kwargs...)(adj_list)
    buchheim(adj_matrix; kwargs...)
    buchheim(adj_list; kwargs...)

Using the algorithm proposed by Buchheim, Junger and Leipert (2002,
[doi 10.1007/3-540-36151-0_32](https://doi.org/10.1007/3-540-36151-0_32)).

Takes adjacency matrix or list representation of given tree
and returns coordinates of the nodes.

## Keyword Arguments
- `Ptype=Float64`: Determines the output type `Point{2,Ptype}`.
- `nodesize=Float64[]`

  Determines the size of each of the node. If network size does not match the
  length of `nodesize` fill up with `ones` or truncate given parameter.
"""
@addcall struct Buchheim{Ptype,T} <: AbstractLayout{2,Ptype}
    nodesize::Vector{T}
end

function Buchheim(; Ptype=Float64, nodesize=Float64[])
    Buchheim{Ptype,eltype(nodesize)}(nodesize)
end

struct Tree{A<:AbstractVector,P<:AbstractVector,F}
    nodes::A
    mod::F
    thread::Vector{Int}
    ancestor::Vector{Int}
    prelim::F
    shift::F
    change::F
    positions::P
    nodesize::F
end

function Tree(tree::AbstractVector, nodesize, Ptype)
    len = length(tree)
    mod = zeros(len)
    thread = zeros(Int, len)
    prelim = zeros(len)
    shift = zeros(len)
    change = zeros(len)
    ancestor = collect(1:len)
    nodes = copy(tree)
    positions = zeros(Point{2,Ptype}, len)
    t = Tree(nodes, mod, thread, ancestor, prelim, shift, change, positions, nodesize)
    return t
end

function adj_mat_to_list(M::AbstractMatrix)
    N = size(M, 1)
    list = Vector{Vector{Int}}(undef, N)
    for i in 1:N
        list[i] = findall(!iszero, view(M, i, :))
    end
    return list
end

function layout(para::Buchheim, adj_matrix::AbstractMatrix)
    assertsquare(adj_matrix)
    list = adj_mat_to_list(adj_matrix)
    layout(para, list)
end

function layout(para::Buchheim{Ptype,T}, adj_list::AbstractVector) where {Ptype,T}
    assert_rooted_tree(adj_list)
    nodesize = ones(T, length(adj_list))
    for i in 1:min(length(adj_list), length(para.nodesize))
        nodesize[i] = para.nodesize[i]
    end

    tree = Tree(adj_list, nodesize, Ptype)
    first_walk(1, tree)
    second_walk(1, -tree.prelim[1], 0.0, tree)
    return tree.positions
end

function parent(v, t::Tree)
    tree = t.nodes
    for i in 1:length(tree)
        if v ∈ tree[i]
            return i
        end
    end
    return nothing
end

function first_walk(v, t::Tree)
    prelim = t.prelim
    mod = t.mod
    tree = t.nodes
    nodesize = t.nodesize
    p = parent(v, t)
    if p != nothing
        index = findall(x -> (x == v), tree[p])[1]
    else
        index = 1
    end
    if length(tree[v]) == 0
        if v != tree[p][1]
            prelim[v] = prelim[tree[p][index - 1]] + (nodesize[tree[p][index - 1]])
        else
            prelim[v] = 0
        end
    else
        defaultAncestor = tree[v][1]
        for w in tree[v]
            first_walk(w, t)
            defaultAncestor = apportion(w, defaultAncestor, t)
        end
        execute_shifts(v, t)
        midpoint = (prelim[tree[v][1]] + prelim[tree[v][end]]) / 2
        if index > 1
            w = tree[p][index - 1]
            prelim[v] = prelim[w] + (nodesize[w] + 1.0)
            mod[v] = prelim[v] - midpoint
        else
            prelim[v] = midpoint
        end
    end
end

function apportion(v::T, defaultAncestor::T, t::Tree) where {T}
    tree = t.nodes
    ancestor = t.ancestor
    prelim = t.prelim
    mod = t.mod
    thread = t.thread
    p = parent(v, t)
    nodesize = t.nodesize
    if p != nothing
        index = findall(x -> (x == v), tree[p])[1]
    else
        index = 1
    end
    if index > 1
        w = tree[p][index - 1]
        v_in_right = v_out_right = v
        v_in_left = w
        v_out_left = tree[parent(v_in_right, t)][1]
        s_in_right = mod[v_in_right]
        s_out_right = mod[v_out_right]
        s_in_left = mod[v_in_left]
        s_out_left = mod[v_out_left]
        while next_right(v_in_left, t) != 0 && next_left(v_in_right, t) != 0
            v_in_left = next_right(v_in_left, t)
            v_in_right = next_left(v_in_right, t)
            v_out_left = next_left(v_out_left, t)
            v_out_right = next_right(v_out_right, t)
            ancestor[v_out_right] = v
            shift = (prelim[v_in_left] + s_in_left) - (prelim[v_in_right] + s_in_right) +
                    (nodesize[v_in_left])
            if shift > 0
                move_subtree(find_ancestor(v_in_left, v, defaultAncestor, t), v, shift, t)
                s_in_right += shift
                s_out_right += shift
            end
            s_in_left += mod[v_in_left]
            s_in_right += mod[v_in_right]
            s_out_left += mod[v_out_left]
            s_out_right += mod[v_out_right]
        end
        if next_right(v_in_left, t) != 0 && next_right(v_out_right, t) == 0
            thread[v_out_right] = next_right(v_in_left, t)
            mod[v_out_right] += s_in_left - s_out_right
        else
            if next_left(v_in_right, t) != 0 && next_left(v_out_left, t) == 0
                thread[v_out_left] = next_left(v_in_right, t)
                mod[v_out_left] += s_in_right - s_out_left
                defaultAncestor = v
            end
        end
    end
    return defaultAncestor
end

function number(v, t::Tree)
    p = parent(v, t)
    index = findall(x -> (x == v), t.nodes[p])[1]
    return index
end

function move_subtree(w_left::T, w_right::T, shift::Float64, t::Tree) where {T}
    change = t.change
    prelim = t.prelim
    tree = t.nodes
    shifttree = t.shift
    mod = t.mod
    n_wl = number(w_left, t)
    n_wr = number(w_right, t)
    subtrees = n_wr - n_wl
    change[w_right] -= shift / subtrees
    shifttree[w_right] += shift
    change[w_left] += shift / subtrees
    prelim[w_right] += shift
    return mod[w_right] += shift
end

function second_walk(v, m::Float64, depth::Float64, t::Tree)
    prelim = t.prelim
    mod = t.mod
    positions = t.positions
    nodesize = t.nodesize
    positions[v] = Point(prelim[v] + m, -depth)
    if length(t.nodes[v]) != 0
        maxdist = maximum([nodesize[i] for i in t.nodes[v]])
    else
        maxdist = 0
    end
    for w in t.nodes[v]
        second_walk(w, m + mod[v], Float64(depth + 1 + maxdist), t)
    end
end

function find_ancestor(w::T, v::T, defaultAncestor::T, tree::Tree) where {T}
    ancestor = tree.ancestor
    if ancestor[w] in tree.nodes[parent(v, tree)]
        return ancestor[w]
    else
        return defaultAncestor
    end
end

function execute_shifts(v, t::Tree)
    tree = t.nodes
    shift = t.shift
    change = t.change
    prelim = t.prelim
    mod = t.mod
    shiftnode = 0
    changenode = 0
    for w in reverse(tree[v])
        prelim[w] += shiftnode
        mod[w] += shiftnode
        changenode += change[w]
        shiftnode += shift[w] + changenode
    end
end

function next_left(v, t::Tree)
    tree = t.nodes
    thread = t.thread
    if length(tree[v]) != 0
        return tree[v][1]
    else
        return thread[v]
    end
end

function next_right(v, t::Tree)
    tree = t.nodes
    thread = t.thread
    if length(tree[v]) != 0
        return tree[v][end]
    else
        return thread[v]
    end
end

"""
    assert_rooted_tree(adj_list::AbstractVector{<:AbstractVector})

Check that
 - every node has only one parent
 - node 1 is head node (has no parent)
 - all nodes are part of the tree

Which are the 3 requirements for a "rooted tree" in the Buchheim paper.
"""
function assert_rooted_tree(adj_list::AbstractVector{<:AbstractVector})
    visited = [false for _ in 1:length(adj_list)]
    for childs in adj_list
        for child in childs
            if visited[child] == false
                visited[child] = true
            else # node was visited before
                throw(ArgumentError("Buchheim assumption broken, this is not a rooted tree: Node $child has multiple parent nodes!"))
            end
        end
    end
    if visited[1] !== false
        throw(ArgumentError("Buchheim assumption broken, this is not a rooted tree: Node 1 needs to be the root!"))
    end
    if !all(view(visited, 2:lastindex(visited)))
        throw(ArgumentError("Buchheim assumption broken, this is not a rooted tree: Some nodes are not part of the tree."))
    end
end

export Align

"""
    Align(inner_layout :: AbstractLayout{2, Ptype}, angle :: Ptype = zero(Ptype))
    
Align the vertex positions of `inner_layout` so that the principal axis of the resulting
layout makes an `angle` with the **x**-axis.
Also automatically centers the layout origin to its center of mass (average node position).

Only supports two-dimensional inner layouts.
"""
@addcall struct Align{Ptype, L <: AbstractLayout{2, Ptype}} <: AbstractLayout{2, Ptype}
    inner_layout :: L
    angle :: Ptype
    function Align(inner_layout::L, angle::Real) where {L <: AbstractLayout{2, Ptype}} where Ptype
        new{Ptype, L}(inner_layout, convert(Ptype, angle))
    end
end
Align(inner_layout::AbstractLayout{2, Ptype}) where Ptype = Align(inner_layout, zero(Ptype))

function layout(algo::Align{Ptype, <:AbstractLayout{2, Ptype}}, adj_matrix::AbstractMatrix) where {Ptype}
    # compute "inner" layout
    rs = layout(algo.inner_layout, adj_matrix)

    # align the "inner" layout to have its principal axis make `algo.angle` with x-axis
    # step 1: compute covariance matrix for PCA analysis: 
    #       C = ∑ᵢ (rᵢ - ⟨r⟩) (rᵢ - ⟨r⟩)ᵀ
    # for vertex positions rᵢ, i = 1, …, N, and center of mass ⟨r⟩ = N⁻¹ ∑ᵢ rᵢ.
    centerofmass = sum(rs) / length(rs)
    C = zeros(SMatrix{2, 2, Ptype})
    for r in rs
        C += (r - centerofmass) * (r - centerofmass)'
    end
    vs = eigen(C).vectors

    # step 2: pick principal axis (largest eigenvalue → last eigenvalue/vector)
    axis = vs[:, end]
    axis_angle = atan(axis[2], axis[1])

    # step 3: rotate positions `rs` so that new axis is aligned with `algo.angle`
    s, c = sincos(-axis_angle + algo.angle)
    R = @SMatrix [c -s; s c] # [cos(θ) -sin(θ); sin(θ) cos(θ)]
    for (i, r) in enumerate(rs)
        rs[i] = Point2{Ptype}(R * (r-centerofmass)) :: Point2{Ptype}
    end

    return rs
end

export SFDP, sfdp

"""
    SFDP(; kwargs...)(adj_matrix)
    sfdp(adj_matrix; kwargs...)

Using the Spring-Electric model suggested by Hu (2005, The Mathematica Journal,
[pdf](http://yifanhu.net/PUB/graph_draw_small.pdf)).

Forces are calculated as:

        f_attr(i,j) = ‖xi - xj‖ ² / K ,    i<->j
        f_repln(i,j) = -CK² / ‖xi - xj‖ ,  i!=j

Takes adjacency matrix representation of a network and returns coordinates of
the nodes.

## Keyword Arguments
- `dim=2`, `Ptype=Float64`: Determines dimension and output type `Point{dim,Ptype}`.
- `tol=1.0`: Stop if position changes of last step `Δp <= tol*K` for all nodes
- `C=0.2`, `K=1.0`: Parameters to tweak forces.
- `iterations=100`: maximum number of iterations
- `initialpos=Point{dim,Ptype}[]`

  Provide `Vector` or `Dict` of initial positions. All positions will be initialized
  using random coordinates between [-1,1]. Random positions will be overwritten using
  the key-val-pairs provided by this argument.

- `pin=[]`: Pin node positions (won't be updated). Can be given as `Vector` or `Dict`
   of node index -> value pairings. Values can be either
    - `(12, 4.0)` : overwrite initial position and pin
    - `true/false` : pin this position
    - `(true, false, false)` : only pin certain coordinates

- `seed=1`: Seed for random initial positions.
- `rng=DEFAULT_RNG[](seed)`

  Create rng based on seed. Defaults to `MersenneTwister`, can be specified
  by overwriting `DEFAULT_RNG[]`
"""
@addcall struct SFDP{Dim,Ptype,T<:AbstractFloat,RNG} <: IterativeLayout{Dim,Ptype}
    tol::T
    C::T
    K::T
    iterations::Int
    initialpos::Dict{Int,Point{Dim,Ptype}}
    pin::Dict{Int,SVector{Dim,Bool}}
    rng::RNG
end

# TODO: check SFDP default parameters
function SFDP(; dim=2, Ptype=Float64,
              tol=1.0, C=0.2, K=1.0,
              iterations=100,
              initialpos=[], pin=[],
              seed=1, rng=DEFAULT_RNG[](seed))
    if !isempty(initialpos)
        dim, Ptype = infer_pointtype(initialpos)
        Ptype = promote_type(Float32, Ptype) # make sure to get at least f32 if given as int
    end
    _initialpos, _pin = _sanitize_initialpos_pin(dim, Ptype, initialpos, pin)

    return SFDP{dim,Ptype,typeof(tol),typeof(rng)}(tol, C, K, iterations, _initialpos, _pin, rng)
end

function Base.iterate(iter::LayoutIterator{<:SFDP{Dim,Ptype,T}}) where {Dim,Ptype,T}
    algo, adj_matrix = iter.algorithm, iter.adj_matrix
    N = size(adj_matrix, 1)
    rng = copy(algo.rng)
    startpos = [2 .* rand(rng, Point{Dim,Ptype}) .- 1 for _ in 1:N]

    for (k, v) in algo.initialpos
        startpos[k] = v
    end

    pin = [get(algo.pin, i, SVector{Dim,Bool}(false for _ in 1:Dim)) for i in 1:N]

    # iteratorstate: (#iter, energy, step, progress, old pos, pin, stopflag)
    return startpos, (1, typemax(T), one(T), 0, startpos, pin, rng, false)
end

function Base.iterate(iter::LayoutIterator{<:SFDP}, state)
    algo, adj_matrix = iter.algorithm, iter.adj_matrix
    iter, energy0, step, progress, locs0, pin, rng, stopflag = state
    K, C, tol = algo.K, algo.C, algo.tol

    # stop if stopflag (tol reached) or nr of iterations reached
    if iter >= algo.iterations || stopflag
        return nothing
    end

    locs = copy(locs0)
    energy = zero(energy0)
    Ftype = eltype(locs)
    N = size(adj_matrix, 1)
    for i in 1:N
        force = zero(Ftype)
        for j in 1:N
            i == j && continue
            if adj_matrix[i, j] == 1
                # Attractive forces for adjacent nodes
                force += Ftype(f_attr(locs[i], locs[j], K) .*
                               ((locs[j] .- locs[i]) / norm(locs[j] .- locs[i])))
            else
                # Repulsive forces
                force += Ftype(f_repln(locs[i], locs[j], C, K) .*
                               ((locs[j] .- locs[i]) / norm(locs[j] .- locs[i])))
            end
        end
        if any(isnan, force)
            # if two points are at the exact same location use random force in any direction
            force = randn(rng, Ftype)
        end
        mask = (!).(pin[i]) # where pin=true mask will multiply with 0
        locs[i] = locs[i] .+ (step .* (force ./ norm(force))) .* mask
        energy = energy + norm(force)^2
    end
    step, progress = update_step(step, energy, energy0, progress)

    # if the tolerance is reached set stopflag to keep claculated point but stop next iteration
    if dist_tolerance(locs, locs0, K, tol)
        stopflag = true
    end

    return locs, (iter + 1, energy, step, progress, locs, pin, rng, stopflag)
end

# Calculate Attractive force
f_attr(a, b, K) = (norm(a .- b) .^ 2) ./ K
# Calculate Repulsive force
f_repln(a, b, C, K) = -C .* (K^2) / norm(a .- b)

function update_step(step, energy::T, energy0, progress) where {T}
    # cooldown step
    t = T(0.9)
    if energy < energy0
        progress = progress + 1
        if progress >= 5
            progress = 0
            step = step / t
        end
    else
        progress = 0
        step = t * step
    end
    return step, progress
end

function dist_tolerance(locs, locs0, K, tol)
    # check whether the layout is optimal
    for i in 1:size(locs, 1)
        if norm(locs[i] .- locs0[i]) >= K * tol
            return false
        end
    end
    return true
end

export Spring, spring

"""
    Spring(; kwargs...)(adj_matrix)
    spring(adj_matrix; kwargs...)

Use the spring/repulsion model of Fruchterman and Reingold (1991,
[doi 10.1002/spe.4380211102](https://doi.org/10.1002/spe.4380211102)) with

- Attractive force:  `f_a(d) =  d^2 / k`
- Repulsive force:  `f_r(d) = -k^2 / d`

where `d` is distance between two vertices and the optimal distance between
vertices `k` is defined as `C * sqrt( area / num_vertices )` where `C` is a parameter
we can adjust

Takes adjacency matrix representation of a network and returns coordinates of
the nodes.

## Keyword Arguments
- `dim=2`, `Ptype=Float64`: Determines dimension and output type `Point{dim,Ptype}`.
- `C=2.0`: Constant to fiddle with density of resulting layout
- `iterations=100`: maximum number of iterations
- `initialtemp=2.0`: Initial "temperature", controls movement per iteration
- `initialpos=Point{dim,Ptype}[]`

  Provide `Vector` or `Dict` of initial positions. All positions will be initialized
  using random coordinates between [-1,1]. Random positions will be overwritten using
  the key-val-pairs provided by this argument.

- `pin=[]`: Pin node positions (won't be updated). Can be given as `Vector` or `Dict`
   of node index -> value pairings. Values can be either
    - `(12, 4.0)` : overwrite initial position and pin
    - `true/false` : pin this position
    - `(true, false, false)` : only pin certain coordinates

- `seed=1`: Seed for random initial positions.
- `rng=DEFAULT_RNG[](seed)`

  Create rng based on seed. Defaults to `MersenneTwister`, can be specified
  by overwriting `DEFAULT_RNG[]`
"""
@addcall struct Spring{Dim,Ptype,RNG} <: IterativeLayout{Dim,Ptype}
    C::Float64
    iterations::Int
    initialtemp::Float64
    initialpos::Dict{Int,Point{Dim,Ptype}}
    pin::Dict{Int,SVector{Dim,Bool}}
    rng::RNG
end

function Spring(; dim=2, Ptype=Float64,
                C=2.0, iterations=100, initialtemp=2.0,
                initialpos=[], pin=[],
                seed=1, rng=DEFAULT_RNG[](seed))
    if !isempty(initialpos)
        dim, Ptype = infer_pointtype(initialpos)
        Ptype = promote_type(Float32, Ptype) # make sure to get at least f32 if given as int
    end
    _initialpos, _pin = _sanitize_initialpos_pin(dim, Ptype, initialpos, pin)

    return Spring{dim,Ptype,typeof(rng)}(C, iterations, initialtemp, _initialpos, _pin, rng)
end

function Base.iterate(iter::LayoutIterator{<:Spring{Dim,Ptype}}) where {Dim,Ptype}
    algo, adj_matrix = iter.algorithm, iter.adj_matrix
    N = size(adj_matrix, 1)
    rng = copy(algo.rng)
    startpos = [2 .* rand(rng, Point{Dim,Ptype}) .- 1 for _ in 1:N]

    for (k, v) in algo.initialpos
        startpos[k] = v
    end

    pin = [get(algo.pin, i, SVector{Dim,Bool}(false for _ in 1:Dim)) for i in 1:N]

    # iteratorstate: #iter nr, old pos, pin
    return (startpos, (1, startpos, pin, rng))
end

function Base.iterate(iter::LayoutIterator{<:Spring}, state)
    algo, adj_matrix = iter.algorithm, iter.adj_matrix
    iteration, old_pos, pin, rng = state
    iteration >= algo.iterations && return nothing

    # The optimal distance bewteen vertices
    N = size(adj_matrix, 1)
    force = similar(old_pos)
    Ftype = eltype(force)
    K = algo.C * sqrt(4.0 / N)

    locs = copy(old_pos)
    # Calculate forces
    for i in 1:N
        force_vec = zero(Ftype)
        for j in 1:N
            i == j && continue
            d = norm(locs[j] .- locs[i])
            if adj_matrix[i, j] != zero(eltype(adj_matrix)) || adj_matrix[j, i] != zero(eltype(adj_matrix))
                # F = d^2 / K - K^2 / d
                F_d = d / K - K^2 / d^2
            else
                # Just repulsive
                # F = -K^2 / d^
                F_d = -K^2 / d^2
            end
            # d  /          sin θ = d_y/d = fy/F
            # F /| dy fy    -> fy = F*d_y/d
            #  / |          cos θ = d_x/d = fx/F
            # /---          -> fx = F*d_x/d
            # dx fx
            if !iszero(d)
                force_vec += Ftype(F_d .* (locs[j] .- locs[i]))
            else
                # if two points are at the exact same location
                # use random force in any direction
                force_vec += randn(rng, Ftype)
            end

        end
        force[i] = force_vec
    end
    # Cool down
    temp = algo.initialtemp / iteration
    # Now apply them, but limit to temperature
    for i in 1:N
        force_mag = norm(force[i])
        iszero(force_mag) && continue
        scale = min(force_mag, temp) ./ force_mag

        mask = (!).(pin[i]) # where pin=true mask will multiply with 0
        locs[i] += force[i] .* scale .* mask
    end

    return locs, (iteration + 1, locs, pin, rng)
end

export SquareGrid, squaregrid

"""
    SquareGrid(; kwargs...)(adj_matrix)
    squaregrid(adj_matrix; kwargs...)

Position nodes on a 2 dimensional rectagular grid. The nodes are placed in order
from upper left to lower right. To skip positions see `skip` argument.

Takes adjacency matrix representation of a network and returns coordinates of
the nodes.

## Keyword Arguments
- `Ptype=Float64`: Determines the output type `Point{2,Ptype}`
- `cols=:auto`: Columns of the grid, the rows are determined automatic. If `:auto` the layout will be square-ish.
- `dx=Ptype(1), dy=Ptype(-1)`: Ofsets between rows/cols.
- `skip=Tuple{Int,Int}[]`: Specify positions to skip when placing nodes.
  `skip=[(i,j)]` means to keep the position in the `i`-th row and `j`-th column
  empty.
"""
@addcall struct SquareGrid{Ptype,CT} <: AbstractLayout{2,Ptype}
    cols::CT
    dx::Ptype
    dy::Ptype
    skip::Vector{Tuple{Int,Int}}
end

function SquareGrid(; Ptype=Float64, cols=:auto, dx=Ptype(1), dy=Ptype(-1), skip=Tuple{Int,Int}[])
    return SquareGrid{Ptype,typeof(cols)}(cols, dx, dy, skip)
end

function layout(algo::SquareGrid{Ptype}, adj_matrix::AbstractMatrix) where {Ptype}
    N = assertsquare(adj_matrix)
    M = N + length(algo.skip)

    if algo.cols === :auto
        cols = (M == 0) ? 0 : (isqrt(M - 1) + 1)
    else
        cols = algo.cols
    end

    positions = Vector{Point2{Ptype}}(undef, N)

    n = 1
    for j in 1:typemax(Int), i in 1:cols
        if (j, i) ∉ algo.skip
            positions[n] = Point2{Ptype}((i - 1) * algo.dx, (j - 1) * algo.dy)
            n += 1
            n > N && break
        end
    end

    return positions
end

using LinearAlgebra: checksquare, norm, pinv, mul!, nullspace

export Stress, stress

"""
    Stress(; kwargs...)(adj_matrix)
    stress(adj_matrix; kwargs...)

Compute graph layout using stress majorization. Takes adjacency matrix
representation of a network and returns coordinates of the nodes.

The main equation to solve is (8) in Gansner, Koren and North (2005,
[doi 10.1007/978-3-540-31843-9_25](https://doi.org/10.1007/978-3-540-31843-9_25)).

## Inputs:
- `adj_matrix`: Matrix of pairwise distances.

## Keyword Arguments
- `dim=2`, `Ptype=Float64`: Determines dimension and output type `Point{dim,Ptype}`.
- `iterations=:auto`: maximum number of iterations (`:auto` means `400*N^2` where `N` are the number of vertices)
- `abstols=0`

   Absolute tolerance for convergence of stress. The iterations terminate if the
   difference between two successive stresses is less than abstol.

- `reltols=10e-6`

  Relative tolerance for convergence of stress. The iterations terminate if the
  difference between two successive stresses relative to the current stress is
  less than reltol.

- `abstolx=10e-6`

  Absolute tolerance for convergence of layout. The iterations terminate if the
  Frobenius norm of two successive layouts is less than abstolx.

- `weights=Array{Float64}(undef, 0, 0)`

  Matrix of weights. If empty (i.e. not specified), defaults to `weights[i,j] = δ[i,j]^-2` if
  `δ[i,j]` is nonzero, or `0` otherwise.

- `initialpos=Point{dim,Ptype}[]`

  Provide `Vector` or `Dict` of initial positions. All positions will be
  initialized using random coordinates from normal distribution. Random
  positions will be overwritten using the key-val-pairs provided by this
  argument.

- `pin=[]`: Pin node positions (won't be updated). Can be given as `Vector` or `Dict`
   of node index -> value pairings. Values can be either
    - `(12, 4.0)` : overwrite initial position and pin
    - `true/false` : pin this position
    - `(true, false, false)` : only pin certain coordinates

- `seed=1`: Seed for random initial positions.
- `rng=DEFAULT_RNG[](seed)`

  Create rng based on seed. Defaults to `MersenneTwister`, can be specified
  by overwriting `DEFAULT_RNG[]`

- `uncon_dist=(maxdist, Ncomps)->maxdist*Ncomps^(1/3)`

  Per default, unconnected vertices in the graph get a pairwise "ideal" distance which scales
  with the number of connected components and the maximum distance within the components.
"""
@addcall struct Stress{Dim,Ptype,IT<:Union{Symbol,Int},FT<:AbstractFloat,M<:AbstractMatrix,F,RNG} <:
                IterativeLayout{Dim,Ptype}
    iterations::IT
    abstols::FT
    reltols::FT
    abstolx::FT
    weights::M
    initialpos::Dict{Int,Point{Dim,Ptype}}
    pin::Dict{Int,SVector{Dim,Bool}}
    uncon_dist::F
    rng::RNG
end

function Stress(; dim=2,
                Ptype=Float64,
                iterations=:auto,
                abstols=0.0,
                reltols=10e-6,
                abstolx=10e-6,
                uncon_dist=(maxd, N)->maxd*N^(1/3),
                weights=Array{Float64}(undef, 0, 0),
                initialpos=[], pin=[],
                seed=1, rng=DEFAULT_RNG[](seed))
    if !isempty(initialpos)
        dim, Ptype = infer_pointtype(initialpos)
        Ptype = promote_type(Float32, Ptype) # make sure to get at least f32 if given as int
    end

    _initialpos, _pin = _sanitize_initialpos_pin(dim, Ptype, initialpos, pin)

    IT, FT, WT, RNG, F = typeof(iterations), typeof(abstols), typeof(weights), typeof(rng), typeof(uncon_dist)
    Stress{dim,Ptype,IT,FT,WT,F,RNG}(iterations, abstols, reltols, abstolx, weights, _initialpos, _pin, uncon_dist, rng)
end

function Base.iterate(iter::LayoutIterator{<:Stress{Dim,Ptype,IT,FT}}) where {Dim,Ptype,IT,FT}
    algo, δ = iter.algorithm, iter.adj_matrix
    N = size(δ, 1)
    M = length(algo.initialpos)
    rng = copy(algo.rng)
    startpos = randn(rng, Point{Dim,Ptype}, N)

    for (k, v) in algo.initialpos
        startpos[k] = v
    end

    if isempty(algo.pin)
        pin = nothing
    else
        isbitstype(Ptype) || error("Pin position only available for isbitstype (got $Ptype)!")
        pin = [get(algo.pin, i, SVector{Dim,Bool}(false for _ in 1:Dim)) for i in 1:N]
        pin = reinterpret(reshape, Bool, pin)
    end

    # calculate iteration if :auto
    maxiter = algo.iterations === :auto ? 400 * N^2 : algo.iterations
    @assert maxiter > 0 "Iterations need to be > 0"

    # if user provided weights not empty try those
    make_symmetric!(δ)
    distances = pairwise_distance(δ, FT)

    # check for unconnected commponents and set pairwise distances
    if any(isequal(typemax(FT)), distances)
        maxd = maximum(filter(isfinite, distances))
        laplacian = weightedlaplacian(δ)
        Ncomponents = size(nullspace(laplacian),2)
        _dist = algo.uncon_dist(maxd, Ncomponents)
        for i in eachindex(distances)
            if isinf(distances[i])
                distances[i] = _dist
            end
        end
    end

    weights = isempty(algo.weights) ? distances .^ (-2) : algo.weights

    @assert length(startpos) == size(δ, 1) == size(δ, 2) == size(weights, 1) == size(weights, 2) "Wrong size of weights?"

    Lw = weightedlaplacian(weights)
    pinvLw = pinv(Lw)
    oldstress = stress(startpos, distances, weights)

    # the `state` of the iterator is (#iter, old stress, old pos, weights, distances pinvLw, pin, stopflag)
    return startpos, (1, oldstress, startpos, weights, distances, pinvLw, maxiter, pin, false)
end

function Base.iterate(iter::LayoutIterator{<:Stress{Dim,Ptype}}, state) where {Dim,Ptype}
    algo, δ = iter.algorithm, iter.adj_matrix
    i, oldstress, oldpos, weights, distances, pinvLw, maxiter, pin, stopflag = state

    if i >= maxiter || stopflag
        return nothing
    end

    # TODO the faster way is to drop the first row and col from the iteration
    t = LZ(oldpos, distances, weights)
    positions = similar(oldpos)
    mul!(positions, pinvLw, (t * oldpos))

    if !isnothing(pin)
        # on pin positions multiply newpos with zero and add oldpos
        _pos = reinterpret(reshape, Ptype, positions)
        _oldpos = reinterpret(reshape, Ptype, oldpos)
        _pos .= ((!).(pin) .* _pos) + (pin .* _oldpos)
    end

    @assert all(x -> all(map(isfinite, x)), positions)
    newstress = stress(positions, distances, weights)

    if abs(newstress - oldstress) < algo.reltols * newstress ||
       abs(newstress - oldstress) < algo.abstols ||
       norm(positions - oldpos) < algo.abstolx
        stopflag = true
    end

    return positions, (i + 1, newstress, positions, weights, distances, pinvLw, maxiter, pin, stopflag)
end

"""
Stress function to majorize

Input:
    positions: A particular layout (coordinates in rows)
    d: Matrix of pairwise distances
    weights: Weights for each pairwise distance

See (1) of Reference
"""
function stress(positions::AbstractArray{Point{T,N}}, d, weights) where {T,N}
    s = zero(T)
    n = length(positions)
    @assert n == size(d, 1) == size(d, 2) == size(weights, 1) == size(weights, 2)
    for j in 1:n, i in 1:(j - 1)
        s += weights[i, j] * (norm(positions[i] - positions[j]) - d[i, j])^2
    end
    @assert isfinite(s)
    return s
end

"""
Compute weighted Laplacian given ideal weights weights

Lʷ defined in (4) of the Reference
"""
function weightedlaplacian(weights::AbstractMatrix{T}) where {T}
    n = checksquare(weights)
    Lw = zeros(T, n, n)
    for i in 1:n
        D = zero(T)
        for j in 1:n
            i == j && continue
            Lw[i, j] = -weights[i, j]
            D += weights[i, j]
        end
        Lw[i, i] = D
    end
    return Lw
end

"""
Computes L^Z defined in (5) of the Reference

Input: Z: current layout (coordinates)
       d: Ideal distances
       weights: weights
"""
function LZ(Z::AbstractVector{Point{N,T}}, d, weights) where {N,T}
    n = length(Z)
    L = zeros(T, n, n)
    for i in 1:n
        D = zero(T)
        for j in 1:n
            i == j && continue
            nrmz = norm(Z[i] - Z[j])
            nrmz == 0 && continue
            δ = weights[i, j] * d[i, j]
            L[i, j] = -δ / nrmz
            D -= -δ / nrmz
        end
        @assert isfinite(D)
        L[i, i] = D
    end
    return L
end

"""
   pairwise_distance(δ)

Calculate the pairwise distances of a the graph from a adjacency matrix
using the Floyd-Warshall algorithm.

https://en.wikipedia.org/wiki/Floyd%E2%80%93Warshall_algorithm
"""
function pairwise_distance(δ, ::Type{T}=Float64) where {T}
    N = size(δ, 1)
    d = Matrix{T}(undef, N, N)
    @inbounds for j in 1:N, i in 1:N
        if i == j
            d[i, j] = zero(eltype(d))
        elseif iszero(δ[i, j])
            d[i, j] = typemax(eltype(d))
        else
            d[i, j] = δ[i, j]
        end
    end

    @inbounds for k in 1:N, i in 1:N, j in 1:N
        if d[i, k] + d[k, j] < d[i, j]
            d[i, j] = d[i, k] + d[k, j]
        end
    end
    return d
end

module NetworkLayout

using GeometryBasics
using LinearAlgebra: norm
using Random
using StaticArrays

export LayoutIterator

"""
Default RNG for layouts.
"""
const DEFAULT_RNG = Ref{DataType}(MersenneTwister)

"""
    AbstractLayout{Dim,Ptype}

Abstract supertype for all layouts. Each layout `Layout <: AbstractLayout` needs to
implement

    layout(::Layout, adj_matrix)::Vector{Point{Dim,Ptype}}

which takes the adjacency matrix representation of a network and returns a list of
node positions. Each `Layout` object holds all of the necessary parameters.

The type parameters specify the returntype `Vector{Point{Dim,Ptype}}`:
- `Dim`: the dimensionality of the layout (i.e. 2 or 3)
- `Ptype`: the type of the returned points (i.e. `Float32` or `Float64`)

By implementing `layout` the Layout also inherits the function-like property

    Layout(; kwargs...)(adj_matrix) -> node_positions
"""
abstract type AbstractLayout{Dim,Ptype} end

dim(::AbstractLayout{Dim,Ptype}) where {Dim,Ptype} = Dim
ptype(::AbstractLayout{Dim,Ptype}) where {Dim,Ptype} = Ptype

(lay::AbstractLayout)(adj_matrix) = layout(lay, adj_matrix)

"""
    IterativeLayout{Dim,Ptype} <: AbstractLayout{Dim,Ptype}

Abstract supertype for iterative layouts. Instead of implementing `layout` directly,
subtypes `Algorithm<:IterativeLayout` need to implement the [iterator
interface](https://docs.julialang.org/en/v1/manual/interfaces/#man-interface-iteration)

    Base.iterate(iter::LayoutIterator{<:Algorithm})
    Base.iterate(iter::LayoutIterator{<:Algorithm}, state)

where the iteration _item_ is a `Vector{Point{Dim,Ptype}}` and the iteration
_state_ depends on the algorithm.

By implementing the iterator interface the `Algorithm` inherits the `layout` and
function-like call

    layout(algo::Algorithm, adj_matrix) -> node_postions
    Algorithm(; kwargs...)(adj_matrix) -> node_positions
"""
abstract type IterativeLayout{Dim,Ptype} <: AbstractLayout{Dim,Ptype} end

"""
    LayoutIterator{T<:IterativeLayout,M<:AbstractMatrix}(algorithm, adj_matrix)

This type bundles an [`IterativeLayout`](@ref) with an adjacency matrix to form an
iterable object whose items are the node positions.

## Example
```
for p in LayoutIterator(Stress(), adj_matrix)
    # do stuff with positions p
end
```
"""
struct LayoutIterator{T<:IterativeLayout,M<:AbstractMatrix}
    algorithm::T
    adj_matrix::M
end

function layout(alg::IterativeLayout, adj_matrix::AbstractMatrix)
    assertsquare(adj_matrix)
    iter = LayoutIterator(alg, adj_matrix)
    next = Base.iterate(iter)
    pos = next[1]
    while next !== nothing
        (item, state) = next
        next = Base.iterate(iter, state)
        pos = next !== nothing ? item : pos
    end
    return pos
end

if !isdefined(Base, :get_extension)
    using Requires
end
@static if !isdefined(Base, :get_extension)
    function __init__()
        @require Graphs = "86223c79-3864-5bf0-83f7-82e725a168b6" begin
            include("../ext/NetworkLayoutGraphsExt.jl")
        end
    end
end

"""
    assertsquare(M)

Throws `ArgumentArror` if matrix is not square. Returns size.
"""
function assertsquare(M::AbstractMatrix)
    (a, b) = size(M)
    a != b && throw(ArgumentError("Adjecency Matrix needs to be square!"))
    return a
end

"""
    make_symmetric!(M::AbstractMatrix)

Pairwise check [i,j] and [j,i]. If one is zero, make symmetric.
If both are different and nonzero throw ArgumentError.
"""
function make_symmetric!(A::AbstractMatrix)
    indsm, indsn = axes(A)
    for i in first(indsn):last(indsn), j in (i):last(indsn)
        if A[i,j] == A[j,i]   # allready symmetric
            continue
        elseif iszero(A[i,j])
            A[i,j] = A[j,i]
        elseif iszero(A[j,i])
            A[j,i] = A[i,j]
        else
            throw(ArgumentError("Matrix can't be symmetrized!"))
        end
    end
    return A
end

"""
Initialpos and pin can be given as diffent types (dicts, vectors, ...)
Sanitize and transform them into

    _initialpos :: Dict{Int,Point{dim,Ptype}}()
    _pin        :: Dict{Int,SVector{dim,Bool}}()
"""
function _sanitize_initialpos_pin(dim, Ptype, initialpos, pin)
    if !isempty(initialpos)
        _initialpos = Dict{Int,Point{dim,Ptype}}(k => Point{dim,Ptype}(v) for (k, v) in pairs(initialpos))
    else
        _initialpos = Dict{Int,Point{dim,Ptype}}()
    end

    _pin = Dict{Int,SVector{dim,Bool}}()
    for (k, v) in pairs(pin)
        if v == nothing
            continue
        elseif v isa Bool
            _pin[k] = SVector{dim,Bool}(v for i in 1:dim)
        else # some container
            if eltype(v) <: Bool
                _pin[k] = v
            else
                # seems to be an initial position
                _initialpos[k] = v
                _pin[k] = SVector{dim,Bool}([true for i in 1:dim])
            end
        end
    end
    return _initialpos, _pin
end

"""
From an point or a colletion of point like objects try to
infer the PType and the dimension.

i.e.
    infer_pointtype([(1,2), (2.3, 4)]) == (2, Float64)
"""
infer_pointtype(::GeometryBasics.AbstractPoint{dim,t}) where {dim,t} = dim, t
infer_pointtype(::NTuple{dim,t}) where {dim,t} = dim, t
infer_pointtype(t::Tuple) = length(t), promote_type(typeof(t).parameters...)
function infer_pointtype(v)
    v = values(v) # needed for broadcast ofer dict
    isempty(v) && throw(ArgumentError("Can not infer pointtype of empty container!"))
    elt = isconcretetype(eltype(v)) ? eltype(v) : promote_type(typeof.(v)...)

    if elt <: Number
        return (length(v), elt)
    else
        ty = infer_pointtype.(v)
        dims = getindex.(ty, 1)
        if !all(isequal(first(dims)), dims)
            throw(ArgumentError("Got container with different point dimesions!"))
        end
        (dims[1], promote_type(getindex.(ty, 2)...))
    end
end

"""
    @addcall

Annotate subtypes of `AbstractLayout` to create a lowercase function call for them.

    @addcall struct MyLayout{Dim, Ptype} <: AbstractLayout{Dim, Ptype}
        para
    end

will add the function

    mylayout(g; kwargs...) = layout(MyLayout(; kwargs...), g)
"""
macro addcall(expr::Expr)
    # assert subtype of abstract layout
    @assert expr.head === :struct "Macro not used on struct!"
    typedef = expr.args[2]
    @assert typedef isa Expr &&
            typedef.head === :<: &&
            typedef.args[2] isa Expr && # supertype
            typedef.args[2].args[1] ∈ [:AbstractLayout, :IterativeLayout] "Macro musst be used on subtype of AbstractLayout"

    if typedef.args[1] isa Symbol # no type parameters
        name = typedef.args[1]
    elseif typedef.args[1] isa Expr && typedef.args[1].head === :curly && typedef.args[1].args[1] isa Symbol
        name = typedef.args[1].args[1]
    else
        throw(ArgumentError("Can't find the layout name!"))
    end

    fname = Symbol(lowercase(String(name)))
    return quote
        Base.@__doc__ $(esc(expr))
        Base.@__doc__ $(esc(fname))(g; kwargs...) = layout($name(; kwargs...), g)
    end
end

include("sfdp.jl")
include("buchheim.jl")
include("spring.jl")
include("stress.jl")
include("spectral.jl")
include("shell.jl")
include("squaregrid.jl")

end

export Shell, shell

"""
    Shell(; kwargs...)(adj_matrix)
    shell(adj_matrix; kwargs...)

Position nodes in concentric circles. Without further arguments all nodes will
be placed on a circle with radius 1.0. Specify placement of nodes using the
`nlist` argument.

Takes adjacency matrix representation of a network and returns coordinates of
the nodes.

## Keyword Arguments
- `Ptype=Float64`: Determines the output type `Point{2,Ptype}`.
- `nlist=Vector{Int}[]`

  Vector of Vector of node indices. Tells the algorithm, which nodes to place on
  which shell from inner to outer. Nodes which are not present in this list will
  be place on additional outermost shell.

This function started as a copy from [IainNZ](https://github.com/IainNZ)'s [GraphLayout.jl](https://github.com/IainNZ/GraphLayout.jl)
"""
@addcall struct Shell{Ptype} <: AbstractLayout{2,Ptype}
    nlist::Vector{Vector{Int}}
end

Shell(; Ptype=Float64, nlist=Vector{Int}[]) = Shell{Ptype}(nlist)

function layout(algo::Shell{Ptype}, adj_matrix::AbstractMatrix) where {Ptype}
    N = assertsquare(adj_matrix)

    nlist = copy(algo.nlist)

    # if the list does not contain all the nodes push missing nodes to new shell
    listed_nodes = Iterators.flatten(nlist)
    @assert allunique(listed_nodes)
    diff = setdiff(1:N, listed_nodes)
    if !isempty(diff)
        push!(nlist, diff)
    end

    # if there is more than one node in the innermost shell start with radius 1.0
    radius = 0.0
    if length(nlist[1]) > 1
        radius = 1.0
    end

    T = Point{2,Ptype}
    locs = Vector{T}(undef, N)
    for nodes in nlist
        # Discard the extra angle since it matches 0 radians.
        θ = range(0; stop=2pi, length=length(nodes) + 1)[1:(end - 1)]
        x = T[(radius * cos(o), radius * sin(o)) for o in θ]
        locs[nodes] = x
        radius += 1.0
    end
    return locs
end

using LinearAlgebra: diag, eigen, Diagonal

export Spectral, spectral

"""
    Spectral(; kwargs...)(adj_matrix)
    spectral(adj_matrix; kwargs...)

This algorithm uses the technique of Spectral Graph Drawing.
For reference see Koren (2003,
[doi 10.1007/3-540-45071-8_50](https://doi.org/10.1007/3-540-45071-8_50)).

Takes adjacency matrix representation of a network and returns coordinates of
the nodes.

## Keyword Arguments
- `dim=3`, `Ptype=Float64`: Determines dimension and output type `Point{dim,Ptype}`.
- `nodeweights=Float64[]`: Vector of weights. If network size does not match the
  length of `nodesize` use `ones` instead.
"""
@addcall struct Spectral{Dim,Ptype,FT<:AbstractFloat} <: AbstractLayout{Dim,Ptype}
    nodeweights::Vector{FT}
end

Spectral(; dim=3, Ptype=Float64, nodeweights=Float64[]) = Spectral{dim,Ptype,eltype(nodeweights)}(nodeweights)

function make_symmetric(adj_matrix::AbstractMatrix)
    adj_matrix = copy(adj_matrix)
    for i in 1:size(adj_matrix, 1), j in (i + 1):size(adj_matrix, 2)
        adj_matrix[i, j] = adj_matrix[j, i] = adj_matrix[i, j] + adj_matrix[j, i]
    end
    return adj_matrix
end

function compute_laplacian(adj_matrix, node_weights)
    n, m = size(adj_matrix)
    # @show size(adj_matrix), size(node_weights)
    @assert n == m == length(node_weights)

    # scale the edge values by the product of node_weights, so that "heavier" nodes also form
    # stronger connections
    adj_matrix = adj_matrix .* sqrt.(node_weights * node_weights')

    # D is a diagonal matrix with the degrees (total weights for that node) on the diagonal
    deg = vec(sum(adj_matrix; dims=1)) - diag(adj_matrix)
    D = Matrix(Diagonal(deg))
    T = eltype(node_weights)
    # Laplacian (L = D - adj_matrix)
    L = T[i == j ? deg[i] : -adj_matrix[i, j] for i in 1:n, j in 1:n]
    return L, D
end

function layout(algo::Spectral{Dim,Ptype,FT}, adj_matrix::AbstractMatrix) where {Dim,Ptype,FT}
    N = assertsquare(adj_matrix)
    # try to use user provided nodeweights
    nodeweights = if length(algo.nodeweights) == N
        algo.nodeweights
    else
        ones(FT, N)
    end

    adj_matrix = make_symmetric(adj_matrix)
    L, D = compute_laplacian(adj_matrix, nodeweights)
    # get the matrix of eigenvectors
    v = eigen(L, D).vectors
    # x, y, and z are the 2nd through 4th eigenvectors of the solution to the
    # generalized eigenvalue problem Lv = λDv
    return map(x -> Point{Dim,Ptype}(x[2:(Dim + 1)]...), eachrow(v))
end

using Documenter
using NetworkLayout
using Graphs
using GraphMakie
using CairoMakie
using StableRNGs

NetworkLayout.DEFAULT_RNG[] = StableRNG
DocMeta.setdocmeta!(NetworkLayout, :DocTestSetup, :(using NetworkLayout); recursive=true)

makedocs(; modules=[NetworkLayout],
         repo=Remotes.GitHub("JuliaGraphs", "NetworkLayout.jl"),
         sitename="NetworkLayout.jl",
         format=Documenter.HTML(; prettyurls=get(ENV, "CI", "false") == "true",
                                canonical="https://juliagraphs.org/NetworkLayout.jl", assets=String[]),
         pages=["Home" => "index.md",
                "Interface" => "interface.md"],
         warnonly=[:missing_docs])

# if gh_pages branch gets to big, check out
# https://juliadocs.github.io/Documenter.jl/stable/man/hosting/#gh-pages-Branch
deploydocs(;repo="github.com/JuliaGraphs/NetworkLayout.jl",
           push_preview=true)

```@meta
CurrentModule = NetworkLayout
```

# NetworkLayout
This is the Documentation for [NetworkLayout](https://github.com/JuliaGraphs/NetworkLayout.jl).

All example images on this page are created using [`Makie.jl`](https://github.com/JuliaPlots/Makie.jl) and the `graphplot` recipe from [`GraphMakie.jl`](https://github.com/JuliaPlots/GraphMakie.jl).

```@example layouts
using CairoMakie
CairoMakie.activate!(type="png") # hide
set_theme!(size=(800, 400)) #hide
using NetworkLayout
using GraphMakie, Graphs
nothing #hide
```

# Basic Usage & Algorithms
All of the algorithms follow the [Layout Interface](@ref). Each layout algorithm
is represented by a type `LayoutAlgorithm <: AbstractLayout`. The parameters of each
layout can be set with keyword arguments. The `LayoutAlgorithm` object itself is
callable and transforms the adjacency matrix and returns a list of `Point{N,T}` from [`GeometryBasics.jl`](https://github.com/JuliaGeometry/GeometryBasics.jl).

```
alg = LayoutAlgorithm(; p1="foo", p2=:bar)
positions = alg(adj_matrix)
```
Each of the layouts comes with a lowercase function version:
```
positions = layoutalgorithm(adj_matrix; p1="foo", b2=:bar)
```

Instead of using the adjacency matrix you can use `AbstractGraph` types from [`Graphs.jl`](https://github.com/JuliaGraphs/Graphs.jl) directly.
```
g = complete_graph(10)
positions = layoutalgorithm(g)
```

## Scalable Force Directed Placement
```@docs
SFDP
```
### Example
```@example layouts
g = wheel_graph(10)
layout = SFDP(Ptype=Float32, tol=0.01, C=0.2, K=1)
f, ax, p = graphplot(g, layout=layout)
hidedecorations!(ax); hidespines!(ax); ax.aspect = DataAspect(); f
```

### Iterator Example
```@example layouts
iterator = LayoutIterator(layout, g)
record(f, "sfdp_animation.mp4", iterator; framerate = 10) do pos
    p[:node_pos][] = pos
    autolimits!(ax)
end
nothing #hide
```
![sfdp animation](sfdp_animation.mp4)

## Buchheim Tree Drawing
```@docs
Buchheim
```
### Example
```@example layouts
adj_matrix = [0 1 1 0 0 0 0 0 0 0;
              0 0 0 0 1 1 0 0 0 0;
              0 0 0 1 0 0 1 0 1 0;
              0 0 0 0 0 0 0 0 0 0;
              0 0 0 0 0 0 0 1 0 1;
              0 0 0 0 0 0 0 0 0 0;
              0 0 0 0 0 0 0 0 0 0;
              0 0 0 0 0 0 0 0 0 0;
              0 0 0 0 0 0 0 0 0 0;
              0 0 0 0 0 0 0 0 0 0]
g = SimpleDiGraph(adj_matrix)
layout = Buchheim()
f, ax, p = graphplot(g, layout=layout)
hidedecorations!(ax); hidespines!(ax); ax.aspect = DataAspect(); f #hide
```

## Spring/Repulsion Model
```@docs
Spring
```
### Example
```@example layouts
g = smallgraph(:cubical)
layout = Spring(Ptype=Float32)
f, ax, p = graphplot(g, layout=layout)
hidedecorations!(ax); hidespines!(ax); ax.aspect = DataAspect(); f #hide
```
### Iterator Example
```@example layouts
iterator = LayoutIterator(layout, g)
record(f, "spring_animation.mp4", iterator; framerate = 10) do pos
    p[:node_pos][] = pos
    autolimits!(ax)
end
nothing #hide
```
![spring animation](spring_animation.mp4)

## Stress Majorization
```@docs
Stress
```
### Example
```@example layouts
g = SimpleGraph(936)
for l in eachline(joinpath(@__DIR__,"..","..","test","jagmesh1.mtx"))
    s = split(l, " ")
    src, dst = parse(Int, s[1]), parse(Int, s[2])
    src != dst && add_edge!(g, src, dst)
end

layout = Stress(Ptype=Float32)
f, ax, p = graphplot(g; layout=layout, node_size=3, edge_width=1)
hidedecorations!(ax); hidespines!(ax); ax.aspect = DataAspect(); f #hide
```

### Iterator Example
```@example layouts
iterator = LayoutIterator(layout, g)
record(f, "stress_animation.mp4", iterator; framerate = 7) do pos
    p[:node_pos][] = pos
    autolimits!(ax)
end
nothing #hide
```
![stress animation](stress_animation.mp4)

##  Shell/Circular Layout
```@docs
Shell
```
```@example layouts
g = smallgraph(:petersen)
layout = Shell(nlist=[6:10,])
f, ax, p = graphplot(g, layout=layout)
hidedecorations!(ax); hidespines!(ax); ax.aspect = DataAspect(); f #hide
```

## SquareGrid Layout
```@docs
SquareGrid
```
```@example layouts
g = Grid((12,4))
layout = SquareGrid(cols=12)
f, ax, p = graphplot(g, layout=layout, nlabels=repr.(1:nv(g)), nlabels_textsize=10, nlabels_distance=5)
ylims!(-4.5,.5); hidedecorations!(ax); hidespines!(ax); ax.aspect = DataAspect(); f #hide
```

## Spectral Layout
```@docs
Spectral
```
```@example layouts
g = watts_strogatz(1000, 5, 0.03; seed=5)
layout = Spectral(dim=2)
f, ax, p = graphplot(g, layout=layout, node_size=0.0, edge_width=1.0)
hidedecorations!(ax); hidespines!(ax); f #hide
f #hide
```
```@example layouts
set_theme!(size=(800, 800)) #hide
using Random; Random.seed!(5) # hide
layout = Spectral()
f, ax, p = graphplot(g, layout=layout, node_size=0.0, edge_width=1.0)
f #hide
```

## `pin` Positions in Interative Layouts
Sometimes it is desired to fix the positions of a few nodes while arranging the rest "naturally" around them.
The iterative layouts [`Stress`](@ref), [`Spring`](@ref) and [`SFDP`](@ref) allow to pin
nodes to certain positions, i.e. those node will stay fixed during the iteration.
```@example layouts
g = SimpleGraph(vcat(hcat(zeros(4,4), ones(4,4)), hcat(ones(4,4), zeros(4,4))))
nothing #hide
```

The keyword argument `pin` takes a Vector or a Dict of key - value pairs. The key has to be
the index of the node. The value can take three forms:
  - `idx => Point2(x,y) ` or `idx => (x,y)` overwrites the initial position of that vertex and pins it there,
  - `idx => true/false` pins or unpins the vertex, position is taken from `initialpos`-keyword argument or random,
  - `idx => (false, true)` allows for fine control over which coordinate to pin.

```@example layouts
initialpos = Dict(1=>Point2f(-1,0.5),
                  3=>Point2f(1,0),
                  4=>Point2f(1,0))
pin = Dict(1=>true,
           2=>(-1,-0.5),
           3=>(true, false),
           4=>(true, false))
nothing #hide
```
Example animation on how those keyword arguments effect different iterative layouts:
```@example layouts
springl = Spring(;initialpos, pin, seed=2)
sfdpl   = SFDP(;initialpos, pin, tol=0.0)
stressl = Stress(;initialpos, pin, reltols=0.0, abstolx=0.0, iterations=100)

f = Figure(size=(1200,500))
ax1 = f[1,1] = Axis(f; title="Spring")
ax2 = f[1,2] = Axis(f; title="SFDP")
ax3 = f[1,3] = Axis(f; title="Stress")

for ax in [ax1, ax2, ax3]
    xlims!(ax,-2,2); ylims!(ax,-1.4,1.4); vlines!(ax, 1; color=:red); hidespines!(ax); hidedecorations!(ax)
end

node_color = vcat(:green, :green, :red, :red, [:black for _ in 1:4])
node_size = vcat([40 for _ in 1:4], [20 for _ in 1:4])
nlabels = vcat("1", "2", "3", "4", ["" for _ in 1:4])
nlabels_align = (:center, :center)
nlabels_color = :white
p1 = graphplot!(ax1, g; layout=springl, node_color, node_size, nlabels, nlabels_align, nlabels_color)
p2 = graphplot!(ax2, g; layout=sfdpl, node_color, node_size, nlabels, nlabels_align, nlabels_color)
p3 = graphplot!(ax3, g; layout=stressl, node_color, node_size, nlabels, nlabels_align, nlabels_color)

iterators = [LayoutIterator(l, g) for l in (springl, sfdpl, stressl)]
record(f, "pin_animation.mp4", zip(iterators...); framerate = 10) do (pos1, pos2, pos3)
    p1[:node_pos][] = pos1
    p2[:node_pos][] = pos2
    p3[:node_pos][] = pos3
end
nothing #hide
```
![pin animation](pin_animation.mp4)

```@meta
CurrentModule = NetworkLayout
```

# Layout Interface

At its core, each layout algorithm is a mapping 
```
graph ↦ node_positions
```
where each layout has several parameters. The main goal of the following interface is to keep the separation between parameters and function call. 
Each layout is implemented as subtype of [`AbstractLayout`](@ref).

```@docs
AbstractLayout
```

Therefore, each `LayoutAlgorithm <: AbstractLayout` is a functor and can be passed around as a function `graph ↦ node_positions` which encapsulates all the parameters. This is handy for plotting libraries such as [GraphMakie.jl](http://juliaplots.org/GraphMakie.jl/previews/PR9/).

There are some additional guidelines:
- All of the parameters should be keyword arguments, i.e. it should be allways
  possible to call `LayoutAlgorithm()` without specifying any parameters.
- Algorithms should allways return `Vector{Point{Dim,Ptype}}`. If the type or
  dimensions can be altered use the keywords `dim` and `Ptype` for it.
- Some parameters may depend on the specific network (i.e. length of start
  positions vector). If possible, there should be a fallback option (i.e.
  truncate the list of start positions if network is to small or append with
  random values).
  
It is convenient to define the lowercase functions 
```
layoutalgorithm(g; kwargs...) = layout(LayoutAlgorihtm(; kwargs...), g)
```
which can done using this macro:
```@docs
@addcall
```

## Iterative Layouts
Iterative layouts are a specific type of layouts which produce a sequence of positions rather than a single list of positions. Those algorithms are implemented as subtypes of [`IterativeLayout`](@ref):

```@docs
IterativeLayout
```

One can instantiate an iterable object [`LayoutIterator`](@ref)
```@docs
LayoutIterator
```
